=== kasten/controllers/view/replace/tests/CMakeLists.txt ===
set(SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/..)

ecm_add_test(
    ${SUTDIR}/replacejob.cpp
    replacejobtest.cpp

    TEST_NAME replacejobtest
    NAME_PREFIX oktetakasten-controllers-replace-
    LINK_LIBRARIES
        OktetaKastenControllersByteArraySearch
        OktetaKastenGui
        OktetaKastenCore
        Qt6::Test
)
target_include_directories(replacejobtest
    PUBLIC
        ${SUTDIR}
)
