=== debian/changelog ===
okteta (5:0.26.23+p24.04+vunstable+git20251130.0203-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 30 Nov 2025 02:03:08 +0000
