## okteta 0.26.23+p24.04+vunstable+git20260102.0029

=== debian/changelog ===
okteta (5:0.26.23+p24.04+vunstable+git20260102.0029-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 02 Jan 2026 00:29:15 +0000
