## okteta 0.26.23+p24.04+vunstable+git20260203.0759

=== debian/changelog ===
okteta (5:0.26.23+p24.04+vunstable+git20260203.0759-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 03 Feb 2026 07:59:24 +0000
